#>
#include <stdlib.h>
#include <string.h>
#include <stdio.h>
#include <time.h>
<#

#>!
char *get_tz(int y, int m, int d, int hh, int mm, int as_offset) {
  int size = 32;
  char *buf;
  struct tm tm;
  time_t t;
  buf = malloc(size * sizeof(char));
  if (hh == -1) { 		// if no hour, assume noon.
    hh = 12; mm = 0;
  }
  memset(&tm, 0, sizeof(tm)); // just to be safe
  tm.tm_year = y - 1900; tm.tm_mon = m; tm.tm_mday = d;
  tm.tm_hour = hh; tm.tm_min = mm;
  t = mktime(&tm);
  localtime_r(&t, &tm);   // localtime sets the tz.
  strftime(buf, size, (as_offset ? "%z" : "%Z"), &tm);
  return (buf);
}
<#

;; return the timezone for the given date as a string,
;; (e.g. "EST"). If as-offset is true, then return it in RFC-822
;; format (e.g. "-0500").

(define (local-timezone y m d #!optional (hr -1) (min -1) (as-offset #f))
  ((foreign-lambda c-string* "get_tz" int int int int int int)
   y m d hr min (if as-offset -1 0)))

;; return the timezone for the given date in SRFI-19 format.

(define (local-timezone/srfi-19 y m d #!optional (hr -1) (min -1))
  (* -36 (read (open-input-string (local-timezone y m d hr min #t)))))

;; Make a date in the local timezone, honouring daylight savings
;; rules. Requires SRFI-19 to work (make-date).

(define (make-local-date nsec sec min hour day month year)
  (make-date nsec sec min hour day month year
             (local-timezone/srfi-19 year month day)))
